'use strict';function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];

  if (_i == null) return;
  var _arr = [];
  var _n = true;
  var _d = false;

  var _s, _e;

  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
var script$1 = {
  name: "Draggable",
  props: {
    classOnDrag: String,
    payload: {
      type: Object,
      default: {}
    }
  },
  emits: ["startDrag", "endDrag"],
  data: function data() {
    return {
      dragInProgress: false,
      originalPosition: {},
      originalSize: {
        height: "100%",
        width: "100%",
        sizeInPc: true
      },
      mouseCoordinates: {
        x: 0,
        y: 0
      },
      eventListeners: []
    };
  },
  computed: {
    elementWidth: function elementWidth() {
      return this.$refs.draggable.offsetWidth;
    },
    elementHeight: function elementHeight() {
      return this.$refs.draggable.offsetHeight;
    },
    left: function left() {
      return this.$refs.draggable.offsetLeft;
    },
    right: function right() {
      return this.$refs.draggable.offsetLeft + this.$refs.draggable.offsetWidth;
    },
    top: function top() {
      return this.$refs.draggable.offsetTop;
    },
    bottom: function bottom() {
      return this.$refs.draggable.offsetTop + this.$refs.draggable.offsetHeight;
    }
  },
  methods: {
    emit: function emit(eventName) {
      this.$emit(eventName, this.payload);
    },
    emitDragStart: function emitDragStart() {
      var startEvent = new CustomEvent("CustomDragStart");
      document.dispatchEvent(startEvent);
      this.emit("startDrag");
    },
    emitDragEnd: function emitDragEnd(x, y) {
      var detail = {
        position: {
          x: x,
          y: y
        },
        payload: this.payload
      };
      this.emit("endDrag");
      var dropEvent = new CustomEvent("CustomDragEnd", {
        detail: detail
      });
      document.dispatchEvent(dropEvent);
    },
    setOriginalPositionAndDimensions: function setOriginalPositionAndDimensions() {
      this.originalPosition.left = this.$refs.draggable.offsetLeft;
      this.originalPosition.top = this.$refs.draggable.offsetTop;
      this.originalSize.height = this.elementHeight;
      this.originalSize.width = this.elementWidth;
      this.originalSize.sizeInPc = false;
    },
    move: function move(_ref) {
      var pageX = _ref.pageX,
          pageY = _ref.pageY;
      if (!this.dragInProgress) return;
      this.setElementPosition(pageY - this.mouseCoordinates.y + "px", pageX - this.mouseCoordinates.x + "px");
    },
    areCoordinatesInElement: function areCoordinatesInElement(x, y) {
      var horizontal = x > this.left && x < this.right;
      var vertical = y > this.top && y < this.bottom;
      return horizontal && vertical;
    },
    setElementPosition: function setElementPosition(top, left) {
      this.$refs.draggable.style.top = top;
      this.$refs.draggable.style.left = left;
      this.$refs.draggable.style.height = this.originalSize.height + "px";
      this.$refs.draggable.style.width = this.originalSize.width + "px";
    },
    startHandler: function startHandler(_ref2) {
      var pageX = _ref2.pageX,
          pageY = _ref2.pageY;
      this.dragInProgress = true;
      this.$refs.draggable.style.height = this.originalSize.height + "px";
      this.$refs.draggable.style.width = this.originalSize.width + "px";
      this.setMouseCoordinates({
        pageX: pageX,
        pageY: pageY
      });
      this.emitDragStart();
    },
    endHandler: function endHandler(_ref3) {
      var pageX = _ref3.pageX,
          pageY = _ref3.pageY;
      this.dragInProgress = false;
      if (this.originalPosition.left !== undefined && this.originalPosition.top !== undefined) this.setElementPosition(this.originalPosition.top + "px", this.originalPosition.left + "px");
      this.mouseCoordinates.x = 0;
      this.mouseCoordinates.y = 0;
      this.emitDragEnd(pageX, pageY);
    },
    touchStart: function touchStart(e) {
      if (!e.targetTouches || e.targetTouches.length !== 1) return;
      this.startHandler(e.targetTouches[0]);
    },
    touchMove: function touchMove(event) {
      if (!event.targetTouches) return;
      if (event.targetTouches.length !== 1) return;
      var touchLocation = event.targetTouches[0];
      this.move(touchLocation);
    },
    touchEnd: function touchEnd(event) {
      if (!event.changedTouches || event.changedTouches.length !== 1) return;
      this.endHandler(event.changedTouches[0]);
    },
    setMouseCoordinates: function setMouseCoordinates(e) {
      this.mouseCoordinates.x = e.pageX - this.left;
      this.mouseCoordinates.y = e.pageY - this.top;
    },
    setup: function setup() {
      var _this = this;

      window.addEventListener("resize", this.setOriginalPositionAndDimensions);
      this.eventListeners.push(document.addEventListener("mousedown", function (e) {
        if (e.button !== 0) return;
        if (!_this.areCoordinatesInElement(e.x, e.y)) return;
        e.preventDefault();

        _this.startHandler(e);
      }));
      this.eventListeners.push(document.addEventListener("mouseup", function (e) {
        if (!_this.dragInProgress) return;

        _this.endHandler(e);
      }));
      this.eventListeners.push(document.addEventListener("mousemove", this.move));
    }
  },
  mounted: function mounted() {
    this.setOriginalPositionAndDimensions();
    this.setup();
    this.$refs.draggable.childNodes.forEach(function (node) {
      node.setAttribute("draggable", "false");
    });
  },
  unmounted: function unmounted() {
    window.removeEventListener("resize");
    this.eventListeners.forEach(function (l) {
      return document.removeEventListener(l);
    });
  }
};function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier /* server only */, shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
    if (typeof shadowMode !== 'boolean') {
        createInjectorSSR = createInjector;
        createInjector = shadowMode;
        shadowMode = false;
    }
    // Vue.extend constructor export interop.
    const options = typeof script === 'function' ? script.options : script;
    // render functions
    if (template && template.render) {
        options.render = template.render;
        options.staticRenderFns = template.staticRenderFns;
        options._compiled = true;
        // functional template
        if (isFunctionalTemplate) {
            options.functional = true;
        }
    }
    // scopedId
    if (scopeId) {
        options._scopeId = scopeId;
    }
    let hook;
    if (moduleIdentifier) {
        // server build
        hook = function (context) {
            // 2.3 injection
            context =
                context || // cached call
                    (this.$vnode && this.$vnode.ssrContext) || // stateful
                    (this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext); // functional
            // 2.2 with runInNewContext: true
            if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
                context = __VUE_SSR_CONTEXT__;
            }
            // inject component styles
            if (style) {
                style.call(this, createInjectorSSR(context));
            }
            // register component module identifier for async chunk inference
            if (context && context._registeredComponents) {
                context._registeredComponents.add(moduleIdentifier);
            }
        };
        // used by ssr in case component is cached and beforeCreate
        // never gets called
        options._ssrRegister = hook;
    }
    else if (style) {
        hook = shadowMode
            ? function (context) {
                style.call(this, createInjectorShadow(context, this.$root.$options.shadowRoot));
            }
            : function (context) {
                style.call(this, createInjector(context));
            };
    }
    if (hook) {
        if (options.functional) {
            // register for functional component in vue file
            const originalRender = options.render;
            options.render = function renderWithStyleInjection(h, context) {
                hook.call(context);
                return originalRender(h, context);
            };
        }
        else {
            // inject component registration as beforeCreate hook
            const existing = options.beforeCreate;
            options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
        }
    }
    return script;
}/* script */
var __vue_script__$1 = script$1;
/* template */

var __vue_render__$1 = function __vue_render__() {
  var _obj;

  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', _vm._b({
    ref: "draggable",
    class: (_obj = {}, _obj[_vm.classOnDrag] = _vm.dragInProgress, _obj),
    style: {
      display: 'flex',
      height: '100%',
      width: '100%',
      position: _vm.dragInProgress ? 'absolute' : undefined
    },
    attrs: {
      "custom-draggable": "true",
      "drag-in-progress": _vm.dragInProgress
    },
    on: {
      "touchstart": _vm.touchStart,
      "touchend": _vm.touchEnd,
      "touchmove": _vm.touchMove
    }
  }, 'div', _vm.$attrs, false), [_vm._t("default")], 2);
};

var __vue_staticRenderFns__$1 = [];
/* style */

var __vue_inject_styles__$1 = undefined;
/* scoped */

var __vue_scope_id__$1 = undefined;
/* module identifier */

var __vue_module_identifier__$1 = "data-v-9fa2b238";
/* functional template */

var __vue_is_functional_template__$1 = false;
/* style inject */

/* style inject SSR */

/* style inject shadow dom */

var __vue_component__$2 = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$1,
  staticRenderFns: __vue_staticRenderFns__$1
}, __vue_inject_styles__$1, __vue_script__$1, __vue_scope_id__$1, __vue_is_functional_template__$1, __vue_module_identifier__$1, false, undefined, undefined, undefined);

var __vue_component__$3 = __vue_component__$2;//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
var script = {
  name: "Dropable",
  emits: ["onDrop"],
  props: {
    dragOverClass: String
  },
  data: function data() {
    return {
      eventListeners: [],
      isBeingDraggedOver: false,
      isGlobalDragInProgress: false
    };
  },
  computed: {
    left: function left() {
      return this.$refs.dropable.offsetLeft;
    },
    right: function right() {
      return this.$refs.dropable.offsetLeft + this.$refs.dropable.offsetWidth;
    },
    top: function top() {
      return this.$refs.dropable.offsetTop;
    },
    bottom: function bottom() {
      return this.$refs.dropable.offsetTop + this.$refs.dropable.offsetHeight;
    }
  },
  methods: {
    dragenterHandler: function dragenterHandler() {
      this.isBeingDraggedOver = true;
    },
    dragleaveHandler: function dragleaveHandler(event) {
      if (event.pageX && event.pageY && this.areCoordinatesInElement(event.pageX, event.pageY)) return;
      this.isBeingDraggedOver = false;
    },
    dropHandler: function dropHandler(event) {
      event.preventDefault();
      this.isBeingDraggedOver = false;
      var pl = event.dataTransfer.getData("payload");
      var payload;
      if (pl) payload = JSON.parse(pl);
      this.$emit("onDrop", payload);
    },
    areCoordinatesInElement: function areCoordinatesInElement(x, y) {
      var horizontal = x > this.left && x < this.right;
      var vertical = y > this.top && y < this.bottom;
      return horizontal && vertical;
    },
    registerEventListeners: function registerEventListeners() {
      var _this = this;

      var vm = this;
      var dropEventListener = document.addEventListener("CustomDragEnd", function (dropEvent) {
        vm.isBeingDraggedOver = false;
        vm.isGlobalDragInProgress = false;
        if (!dropEvent.detail || !dropEvent.detail.position) return;
        var _dropEvent$detail$pos = dropEvent.detail.position,
            x = _dropEvent$detail$pos.x,
            y = _dropEvent$detail$pos.y;
        if (!vm.areCoordinatesInElement(x, y)) return;
        vm.$emit("onDrop", dropEvent.detail.payload);
      });
      vm.eventListeners.push(dropEventListener);
      var dragStartEventListener = document.addEventListener("CustomDragStart", function () {
        vm.isGlobalDragInProgress = true;
      });
      vm.eventListeners.push(dragStartEventListener);
      var touchMoveListener = document.addEventListener("touchmove", function (touchEvent) {
        if (!touchEvent || !touchEvent.target || !touchEvent.target.parentElement) return;
        if (touchEvent.target.parentElement.getAttribute("custom-draggable") !== "true") return;
        if (!touchEvent.targetTouches || touchEvent.targetTouches.length !== 1) return;
        var currentTouch = touchEvent.targetTouches[0];
        if (!currentTouch.pageX || !currentTouch.pageY) return;

        if (vm.areCoordinatesInElement(currentTouch.pageX, currentTouch.pageY)) {
          vm.isBeingDraggedOver = true;
        } else {
          vm.isBeingDraggedOver = false;
        }
      });
      vm.eventListeners.push(touchMoveListener);
      var dragEndListener = document.addEventListener("dragend", function () {
        vm.isBeingDraggedOver = false;
      });
      vm.eventListeners.push(dragEndListener);
      var mouseMoveEventListener = document.addEventListener("mousemove", function (mouseEvent) {
        if (!vm.isGlobalDragInProgress) return;

        if (!vm.areCoordinatesInElement(mouseEvent.pageX, mouseEvent.pageY)) {
          _this.isBeingDraggedOver = false;
          return;
        }

        _this.isBeingDraggedOver = true;
      });
      vm.eventListeners.push(mouseMoveEventListener);
    },
    deregisterEventListeners: function deregisterEventListeners() {
      if (this.eventListeners.length) this.eventListeners.forEach(function (listener) {
        return document.removeEventListener(listener);
      });
    }
  },
  mounted: function mounted() {
    this.registerEventListeners();
  },
  unmounted: function unmounted() {
    this.deregisterEventListeners();
  }
};/* script */
var __vue_script__ = script;
/* template */

var __vue_render__ = function __vue_render__() {
  var _obj;

  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', _vm._b({
    ref: "dropable",
    class: (_obj = {}, _obj[_vm.dragOverClass] = _vm.isBeingDraggedOver, _obj),
    attrs: {
      "id": "drop-handler"
    },
    on: {
      "drop": _vm.dropHandler,
      "dragenter": function dragenter($event) {
        $event.preventDefault();
        return _vm.dragenterHandler.apply(null, arguments);
      },
      "dragover": function dragover($event) {
        $event.preventDefault();
      },
      "dragleave": _vm.dragleaveHandler
    }
  }, 'div', _vm.$attrs, false), [_vm._t("default")], 2);
};

var __vue_staticRenderFns__ = [];
/* style */

var __vue_inject_styles__ = undefined;
/* scoped */

var __vue_scope_id__ = undefined;
/* module identifier */

var __vue_module_identifier__ = "data-v-259ce05e";
/* functional template */

var __vue_is_functional_template__ = false;
/* style inject */

/* style inject SSR */

/* style inject shadow dom */

var __vue_component__ = /*#__PURE__*/normalizeComponent({
  render: __vue_render__,
  staticRenderFns: __vue_staticRenderFns__
}, __vue_inject_styles__, __vue_script__, __vue_scope_id__, __vue_is_functional_template__, __vue_module_identifier__, false, undefined, undefined, undefined);

var __vue_component__$1 = __vue_component__;/* eslint-disable import/prefer-default-export */var components$1=/*#__PURE__*/Object.freeze({__proto__:null,Draggable:__vue_component__$3,Dropable:__vue_component__$1});var install = function installVueCrossPlatformDragDrop(Vue) {
  Object.entries(components$1).forEach(function (_ref) {
    var _ref2 = _slicedToArray(_ref, 2),
        componentName = _ref2[0],
        component = _ref2[1];

    Vue.component(componentName, component);
  });
}; // Create module definition for Vue.use()
var components=/*#__PURE__*/Object.freeze({__proto__:null,'default':install,Draggable:__vue_component__$3,Dropable:__vue_component__$1});// only expose one global var, with component exports exposed as properties of
// that global var (eg. plugin.component)

Object.entries(components).forEach(function (_ref) {
  var _ref2 = _slicedToArray(_ref, 2),
      componentName = _ref2[0],
      component = _ref2[1];

  if (componentName !== 'default') {
    install[componentName] = component;
  }
});module.exports=install;